package provider

import scala.concurrent.Future

class Database[Key, Entry](
    private val content: Map[Key, Entry]
) extends Provider[Key, Entry]:
  def retrieve(key: Key): Future[Entry] =
    if content.contains(key) then
      Future.successful(content(key))
    else
      Future.failed(new Exception("Key not found"))

  def retrieveKeys: Future[Set[Key]] =
    Future.successful(content.keySet)

class DatabaseSync[Key, Entry](
    private val content: Map[Key, Entry]
) extends ProviderSync[Key, Entry]:
  // Deprecated
  def retrieveSync(key: Key): Option[Entry] =
    content.get(key)

  // Deprecated
  def retrieveKeysSync: Set[Key] =
    content.keySet
