package provider

import scala.concurrent.Future
import concurrent.ExecutionContext.Implicits.global

class PlaylistResolverSync(
    musicProvider: MusicProviderSync,
    playlistProvider: PlaylistProviderSync[MusicKey]
) extends PlaylistProviderSync[MusicEntry]:
  def retrieveSync(key: PlaylistKey): Option[List[MusicEntry]] =
    val playlist = playlistProvider.retrieveSync(key)
    playlist.map {
      _.map { key =>
        musicProvider.retrieveSync(key)
      }.flatten
    }
  def retrieveKeysSync: Set[PlaylistKey] =
    playlistProvider.retrieveKeysSync

class PlaylistResolver(
    musicProvider: MusicProvider,
    playlistProvider: PlaylistProvider[MusicKey]
) extends PlaylistProvider[MusicEntry]:
  def retrieve(key: PlaylistKey): Future[List[MusicEntry]] =
    ???

  def retrieveKeys: Future[Set[PlaylistKey]] =
    ???
