package provider

object TestDb:
  val dbContentEU = Map(
    MusicKey("1") -> MusicEntry(
      MusicKey("1"),
      "Metallica",
      "Metallica",
      "Enter Sandman",
      1991,
      MusicData(Vector[Byte](7, 8, 9))
    ),
    MusicKey("2") -> MusicEntry(
      MusicKey("2"),
      "Metallica",
      "Metallica",
      "Sad but True",
      1991,
      MusicData(Vector[Byte](10, 11, 12))
    ),
    MusicKey("3") -> MusicEntry(
      MusicKey("3"),
      "Metallica",
      "Metallica",
      "Nothing Else Matters",
      1991,
      MusicData(Vector[Byte](13, 14, 15))
    ),
    MusicKey("4") -> MusicEntry(
      MusicKey("4"),
      "Metallica",
      "Metallica",
      "Wherever I May Roam",
      1991,
      MusicData(Vector[Byte](16, 17, 18))
    ),
    MusicKey("5") -> MusicEntry(
      MusicKey("5"),
      "Metallica",
      "And Justice for All",
      "One",
      1988,
      MusicData(Vector[Byte](19, 20, 21))
    ),
    MusicKey("6") -> MusicEntry(
      MusicKey("6"),
      "Iron Maiden",
      "The Number of the Beast",
      "The Number of the Beast",
      1982,
      MusicData(Vector[Byte](22, 23, 24))
    ),
    MusicKey("7") -> MusicEntry(
      MusicKey("7"),
      "Iron Maiden",
      "The Number of the Beast",
      "Run to the Hills",
      1982,
      MusicData(Vector[Byte](25, 26, 27))
    ),
    MusicKey("8") -> MusicEntry(
      MusicKey("8"),
      "Dua Lipa",
      "Future Nostalgia",
      "Don't Start Now",
      2020,
      MusicData(Vector[Byte](28, 29, 30))
    ),
    MusicKey("9") -> MusicEntry(
      MusicKey("9"),
      "Dua Lipa",
      "Future Nostalgia",
      "Physical",
      2020,
      MusicData(Vector[Byte](31, 32, 33))
    ),
    MusicKey("10") -> MusicEntry(
      MusicKey("10"),
      "Elton John",
      "Goodbye Yellow Brick Road",
      "Candle in the Wind",
      1973,
      MusicData(Vector[Byte](34, 35, 36))
    ),
    MusicKey("21") -> MusicEntry(
      MusicKey("21"),
      "Rolling Stones",
      "Sticky Fingers",
      "Brown Sugar",
      1971,
      MusicData(Vector[Byte](55, 56, 57))
    ),
    MusicKey("22") -> MusicEntry(
      MusicKey("22"),
      "Rolling Stones",
      "Sticky Fingers",
      "Wild Horses",
      1971,
      MusicData(Vector[Byte](58, 59, 60))
    ),
    MusicKey("23") -> MusicEntry(
      MusicKey("23"),
      "LeviathanJPTV",
      "Single",
      "Chug Jug With You",
      2021,
      MusicData(Vector[Byte](61, 62, 63))
    ),
    MusicKey("25") -> MusicEntry(
      MusicKey("25"),
      "Not Dua Lipa",
      "Not Future Nostalgia",
      "Levitating",
      2020,
      MusicData(Vector[Byte](67, 68, 69))
    )
  )

  val dbContentUS = Map(
    MusicKey("1") -> MusicEntry(
      MusicKey("1"),
      "Metallica",
      "Metallica",
      "Enter Sandman",
      1991,
      MusicData(Vector[Byte](7, 8, 9))
    ),
    MusicKey("2") -> MusicEntry(
      MusicKey("2"),
      "Metallica",
      "Metallica",
      "Sad but True",
      1991,
      MusicData(Vector[Byte](10, 11, 12))
    ),
    MusicKey("3") -> MusicEntry(
      MusicKey("3"),
      "Metallica",
      "Metallica",
      "Nothing Else Matters",
      1991,
      MusicData(Vector[Byte](13, 14, 15))
    ),
    MusicKey("10") -> MusicEntry(
      MusicKey("10"),
      "Elton John",
      "Goodbye Yellow Brick Road",
      "Candle in the Wind",
      1973,
      MusicData(Vector[Byte](34, 35, 36))
    ),
    MusicKey("11") -> MusicEntry(
      MusicKey("11"),
      "Elton John",
      "Goodbye Yellow Brick Road",
      "Bennie and the Jets",
      1973,
      MusicData(Vector[Byte](37, 38, 39))
    ),
    MusicKey("12") -> MusicEntry(
      MusicKey("12"),
      "Led Zeppelin",
      "Led Zeppelin IV",
      "Stairway to Heaven",
      1971,
      MusicData(Vector[Byte](40, 41, 42))
    ),
    MusicKey("13") -> MusicEntry(
      MusicKey("13"),
      "Led Zeppelin",
      "Led Zeppelin IV",
      "Rock and Roll",
      1971,
      MusicData(Vector[Byte](43, 44, 45))
    ),
    MusicKey("14") -> MusicEntry(
      MusicKey("14"),
      "The Beatles",
      "Abbey Road",
      "Come Together",
      1969,
      MusicData(Vector[Byte](46, 47, 48))
    ),
    MusicKey("15") -> MusicEntry(
      MusicKey("15"),
      "The Beatles",
      "Abbey Road",
      "Here Comes the Sun",
      1969,
      MusicData(Vector[Byte](49, 50, 51))
    ),
    MusicKey("16") -> MusicEntry(
      MusicKey("16"),
      "The Beatles",
      "Abbey Road",
      "Because",
      1969,
      MusicData(Vector[Byte](52, 53, 54))
    ),
    MusicKey("17") -> MusicEntry(
      MusicKey("17"),
      "The Beatles",
      "Abbey Road",
      "You Never Give Me Your Money",
      1969,
      MusicData(Vector[Byte](55, 56, 57))
    ),
    MusicKey("24") -> MusicEntry(
      MusicKey("24"),
      "Dua Lipa",
      "Future Nostalgia",
      "Levitating",
      2020,
      MusicData(Vector[Byte](64, 65, 66))
    )
  )

  /** Playlist database content
    *
    *   - PlaylistKey("1") is a playlist with songs only on EU server
    *   - PlaylistKey("2") is a playlist with songs only on US server
    *   - PlaylistKey("3") is a playlist with songs on both servers (some are on
    *     both servers, some are only on one server)
    */
  val plalistDbContent = Map(
    PlaylistKey("1") -> List(
      MusicKey("4"),
      MusicKey("5"),
      MusicKey("6")
    ),
    PlaylistKey("2") -> List(
      MusicKey("14"),
      MusicKey("15"),
      MusicKey("16")
    ),
    PlaylistKey("3") -> List(
      MusicKey("1"),
      MusicKey("2"),
      MusicKey("3"),
      MusicKey("4"),
      MusicKey("5"),
      MusicKey("6"),
      MusicKey("7"),
      MusicKey("21"),
      MusicKey("22"),
      MusicKey("23"),
      MusicKey("24"),
      MusicKey("25")
    )
  )

  val musicProviderEU: MusicProvider = Database(dbContentEU)
  val musicProviderUS: MusicProvider = Database(dbContentUS)

  val playlistProvider: PlaylistProvider[MusicKey] =
    Database(plalistDbContent)
